# Meshes.jl

[![Build Status](https://travis-ci.com/JuliaGeometry/Meshes.jl.svg?branch=master)](https://travis-ci.com/JuliaGeometry/Meshes.jl)
[![Codecov](https://codecov.io/gh/JuliaGeometry/Meshes.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaGeometry/Meshes.jl)

This package provides efficient implementations of concepts from
computational geometry and finite element analysis. It promotes
rigorous mathematical definitions of spatial discretizations
(a.k.a. meshes) that are adequate for describing general
manifolds embedded in Rⁿ, including surfaces described with
spherical coordinates, and geometries described with multiple
coordinate reference systems.

## Usage

The package is being actively developed. We kindly ask users to
read the source code, the tests, and the docstrings for usage
examples.

## Contributing

Contributions are very welcome, as are feature requests and suggestions.
Please open an issue if you encounter any problems. We take issues very
seriously and value any type of feedback.

We have high standards when it comes to source code. Please adopt the
coding style that is present in the files when submitting pull requests.
