using Meshes
using Test, Pkg, Random

# workaround GR warnings
ENV["GKSwstype"] = "100"

# environment settings
islinux = Sys.islinux()
istravis = "TRAVIS" ∈ keys(ENV)
isappveyor = "APPVEYOR" ∈ keys(ENV)
isCI = istravis || isappveyor
datadir = joinpath(@__DIR__,"data")

# list of tests
testfiles = [
  "points.jl",
  "faces.jl",
  "polygons.jl",
  "primitives.jl",
  "meshes.jl",
  "sampling.jl",
  "boundingboxes.jl"
]

# run tests with single precision
T = Float32
P2, P3 = Point{2,T}, Point{3,T}
V2, V3 = Vec{2,T}, Vec{3,T}
@testset "Meshes.jl ($T)" begin
  for testfile in testfiles
    include(testfile)
  end
end

# run tests with double precision
T = Float64
P2, P3 = Point{2,T}, Point{3,T}
V2, V3 = Vec{2,T}, Vec{3,T}
@testset "Meshes.jl ($T)" begin
  for testfile in testfiles
    include(testfile)
  end
end
